without type_check
include image.e
include pic_load.e
include get.e
include mouse.e

object temp,x1
sequence background,pal,blocks,levels,contact
atom a,b,c,d,x,y,z,u,v,w,level
-------------------------
function clip_it(atom x, atom y, atom n)
temp=repeat(0,n)
x=x+1 --adjust for the 0 vs 1 thing...
for i = 1 to n do
  temp[i]=repeat(0,b)
  for j=1 to b do
    temp[i][j]=contact[y+j+d*(i-1)][x+c*(i-1)..x+a+c*(i-1)]
    end for
end for
return temp
end function
--------------------
sequence pac,ghost,eyes,gize,dot
 
temp=read_gif("contact2.gif")
pal=temp[1]/4 
contact=temp[2]
a=11 b=8 c=13 d=0  --width, height, hstep, vstep
pac=clip_it(66,46,1)
ghost=clip_it(209,19,1)
dot=clip_it(287,19,1)
eyes=clip_it(1,28,1)
gize=clip_it(1,46,1)
blocks=clip_it(1,1,25)&dot&pac&ghost&gize&clip_it(222,46,6)&(pac-pac)



--color ghost and add eyes to it
for l= 1 to 8 do
  for k = 1 to 12 do
   if blocks[28][l][k]=2 then blocks[28][l][k]=32 end if
    a=eyes[1][l][k] 
   if a>0 then blocks[28][l][k]=a end if
  end for 
end for




x=open("levels.lod","r")
temp=get(x)
if temp[1]!=GET_FAIL then levels=temp[2]
else levels=repeat(0,22)
for i = 1 to 22 do
levels[i]=repeat(' ',19)
end for 
end if
close(x)
------------------------
level=1

x=graphics_mode(19)
text_color(1)
temp = read_gif("mazed.gif")
background=temp[2]
   
all_palette(pal)
display_image({0,0},background)
display_image({285,112},blocks[33])

-------------------------------
procedure drawlevel()
atom q,p
display_image({0,0},background)
--display_image({295,42},blocks[19])
--display_image({295,52},blocks[20])
p=floor(length(levels)/22)
--position(22,31) puts(1,"Level ") print(1,level)puts(1,"  ")
--position(23,31) puts(1,"of ")print(1,p)puts(1,"     ")
--position(24,31) puts(1,"        ")
mouse_pointer(0)
q=(level-1)*22+1
temp=levels[q..q+22]
for i=1 to 22 do
for j=1 to 19 do      
w=temp[i][j]
y=0
if    w='=' then y=1
elsif w='<' then y=2
elsif w='>' then y=3
elsif w=')' then y=4
elsif w='T' then y=5
elsif w='(' then y=6
elsif w='^' then y=7
elsif w=']' then y=8

elsif w='t' then y=9
elsif w='[' then y=10
elsif w='I' then y=11
elsif w='U' then y=12
elsif w='L' then y=13
elsif w='+' then y=14
elsif w='7' then y=15


elsif w='o' then y=26
elsif w='O' then y=29
elsif w=' ' then y=36
elsif w='q' then y=16
elsif w='w' then y=17
elsif w='e' then y=18
elsif w='r' then y=19
elsif w='a' then y=20
elsif w='z' then y=21
elsif w='d' then y=22
elsif w='f' then y=23

elsif w='C' then y=27
elsif w='M' then y=28
elsif w='S' then y=30
elsif w='s' then y=33
elsif w='P' then y=31
elsif w='p' then y=34
elsif w='G' then y=32
elsif w='g' then y=35
elsif w='X' then y=36

end if
if y>0 then display_image({(j-1)*12+1+3,(i)*8-1+4},blocks[y]) end if
end for end for
 --w=save_screen(0,"maze"&sprintf("%02d",level)&".bmp")
mouse_pointer(1)
end procedure
----------------------------   
procedure clearlevel()
atom q
q=(level-1)*22
for i = 1 to 22 do
levels[q+i]=repeat(' ',19)
end for
--drawlevel()
display_image({0,0},background)
end procedure
----------------------------
procedure backlevel()
integer p
p=floor(length(levels)/22)
level=level-1
if level<1 then level=p end if
drawlevel()
end procedure
----------------------------
procedure nextlevel()
integer p,q
p=floor(length(levels)/22)
--print(1,p) puts(1," ") print(1,level)
if p=level then position (23,31) puts(1,"New Level?\n\r")
		position(24,31) puts(1,"(Y/N):")
 q=wait_key()
 if q='y' or q='Y' then 
    temp=repeat(0,22)
    for i = 1 to 22 do
      temp[i]=repeat(' ',19)
      end for
     --x1=append(levels,temp)
     --levels=x1
     levels=levels&temp
     p=p+1
     level=level+1
 else p=1 level=1 position(23,31) puts(1,"          ") position(24,31)
				  puts(1,"          ")      
 end if    
 else level=level+1
 end if
 drawlevel()
-- x=-1
end procedure
mouse_pointer(1)
drawlevel()
x=-1
y=1 w='#'--block type
while x=-1 do

--249,42  265,42 
x=get_key()
x1=get_mouse()
if sequence(x1) then  x1[2]=x1[2]/2
if x1[1]=2 then
   position(25,31)

   if x1[2]>240 and x1[2]<255 then
      if x1[3]>121 and x1[3]<127 then puts(1,"Clear  ") clearlevel()
      elsif x1[3]>130 and x1[3]<136 then puts(1,"Back   ") backlevel()
      elsif x1[3]>139 and x1[3]<145 then puts(1,"Next   ") nextlevel()
      elsif x1[3]>148 and x1[3]<154 then puts(1,"Quit   ") x=5
      end if end if
  
   if x1[2]>249 and x1[2]<262 then
      if    x1[3]>32 and x1[3]<40 then  puts(1,"UR Bumper") y=16 w='q'
      elsif x1[3]>42 and x1[3]<50 then  puts(1,"flat     ") y=1 w='=' 
      elsif x1[3]>52 and x1[3]<60 then  puts(1,"Lend     ") y=2 w='<'
      elsif x1[3]>62 and x1[3]<70 then  puts(1,"R end    ") y=3 w='>'
      elsif x1[3]>72 and x1[3]<80 then  puts(1,"UR cor   ") y=4 w=')'
      elsif x1[3]>82 and x1[3]<90 then  puts(1,"DownT    ") y=5 w='T'
      elsif x1[3]>92 and x1[3]<100 then puts(1,"UL cor   ") y=6 w='('
      elsif x1[3]>102 and x1[3]<110  then puts(1,"PH door") y=31 w='P'

      end if
    elsif x1[2]>265 and x1[2]<279 then
       if   x1[3]>32 and x1[3]<40 then  puts(1,"UR Bumper") y=17 w='w'
      elsif x1[3]>42 and x1[3]<50  then puts(1,"Uvert end") y=7 w='^'
      elsif x1[3]>52 and x1[3]<60  then puts(1,"LR Cor   ") y=8 w=']'
      elsif x1[3]>62 and x1[3]<70  then puts(1,"Up T     ") y=9 w='t'
      elsif x1[3]>72 and x1[3]<80  then puts(1,"LL Cor   ") y=10 w='['
      elsif x1[3]>82 and x1[3]<90  then puts(1,"Vert     ") y=11 w='I' 
      elsif x1[3]>92 and x1[3]<100 then puts(1,"Dvert end") y=12 w='U'
      elsif x1[3]>102 and x1[3]<110  then puts(1,"PV  door")y=34 w='p'
     

      end if
  
    elsif x1[2]>279 and x1[2]<292 then
      if    x1[3]>32 and x1[3]<40 then  puts(1,"LL Bumper") y=18 w='e'
      elsif x1[3]>42 and x1[3]<50  then puts(1,"L elbow  ") y=13 w='L'
      elsif x1[3]>52 and x1[3]<60  then puts(1,"Vert +   ") y=14 w='+'
      elsif x1[3]>62 and x1[3]<70  then puts(1,"R elbow  ") y=15 w='7'
      elsif x1[3]>72 and x1[3]<80  then puts(1,"Dot      ") y=26 w='o'
      elsif x1[3]>82 and x1[3]<90  then puts(1,"Energizer") y=29 w='O' 
      elsif x1[3]>92 and x1[3]<100 then puts(1,"Eraser!  ") y=36 w=' '
      elsif x1[3]>102 and x1[3]<110  then puts(1,"Lowbump") y=20 w='a'
      elsif x1[3]>112 and x1[3]<120  then puts(1,"l bumper")y=22 w='d'
    end if
    
   elsif x1[2]>295 and x1[2]<307 then
      if    x1[3]>32 and x1[3]<40 then  puts(1,"LR Bumper") y=19 w='r'
      elsif x1[3]>42 and x1[3]<50  then puts(1,"Pacman") y=27 w='C'  
      elsif x1[3]>52 and x1[3]<60  then puts(1,"Ghost") y=28 w='M'
      elsif x1[3]>62 and x1[3]<70  then puts(1,"V door  ")y=33 w='s'
      elsif x1[3]>72 and x1[3]<80  then puts(1,"H door  ")y=30 w='S'
      elsif x1[3]>82 and x1[3]<90  then puts(1,"GV door ")y=35 w='g'
      elsif x1[3]>92 and x1[3]<100  then puts(1,"GH door")y=32 w='G'
      elsif x1[3]>102 and x1[3]<110 then puts(1,"hibump ") y=21 w='z'
      elsif x1[3]>112 and x1[3]<120  then puts(1,"R bumper")y=23 w='f'
 

    end if
--mouse in the box

     elsif x1[2]>0 and x1[2]<228 and x1[3]>6 and x1[3]<184 then
      u=floor((x1[2])/12) v=floor((x1[3])/8) 
      mouse_pointer(0)
      --if levels[v+1][u+1]=w then y=8 w=' 'end if
      display_image({u*12+1+3,v*8-1+4},blocks[y])
       
	 levels[(level-1)*22+v][u+1]=w 
      mouse_pointer(1)
    end if
   end if
end if      
end while
x=graphics_mode(-1)
clear_screen()
x=open("levels.lod","w")
--levels=levels[23..length(levels)] --drop first one
print(x,levels)

close(x)

x=open ("levels2.txt","w")
for i = 1 to length(levels) do
puts(x,levels[i]&"\n")
end for
close(x)
--x=wait_key()
abort(0)


